#ifndef MCMC_CK
#define MCMC_CK

#include "DispMessage.h"
#include"RNP2to191.h"

using namespace EstPolychoric;
using namespace rnp2to191;

namespace MyMCMC {

	ref class MCMCPolyChoric {
	public:
		String ^ hstr;
		RNP2to191 * rn;
		int Kx, Ky;
		double ** Cx, ** Cy;
		int * X, * Y;
		double * rho;
		int ** Nkh;
		int N;
		int NSimu;
		double * sgmCx, *sgmCy, sgm_rho;
		int * cntCx, *cntCy, cnt_rho;

		MCMCPolyChoric(){}
		virtual ~MCMCPolyChoric(){
			ClearMe();
		}
		!MCMCPolyChoric(){
			ClearMe();
		}

		void ClearMe();

		void Init(String ^ vhstr, int vnjump, int vNSimu, int vKx, int vKy, int vN, int * vX, int * vY,
					double init_rho, double * init_Cx, double * init_Cy,
					double vsgm_rho, double * vsgmCx, double * vsgmCy);
		
		double LProbAll(double vrho, double * vCx, double * vCy);

		double LProbCx(int vCk, double * vCx, int imcmc);

		double LProbCy(int vCh, double * vCy, int imcmc);

		void do_mcmc();
		
	};
}

#endif
